<html>
<head>
<title>Ogre::VertexData Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::VertexData Class Reference<div class="ingroups"><a class="el" href="group__RenderSystem.html">RenderSystem</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::VertexData" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>Summary class collecting together vertex source information.  
 <a href="classOgre_1_1VertexData.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::VertexData:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1VertexData__inherit__graph.gif" border="0" usemap="#Ogre_1_1VertexData_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1VertexData_inherit__map" id="Ogre_1_1VertexData_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="8,5,125,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1VertexData-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html">HardwareAnimationData</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Struct used to hold hardware morph / pose vertex data information.  <a href="structOgre_1_1VertexData_1_1HardwareAnimationData.html#details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a><br class="typebreak"/>
&lt; <a class="el" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html">HardwareAnimationData</a> &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a8cbc3dcd7a4375b35b8595df246756e9">HardwareAnimationDataList</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a2396c78b8d5353f2f0f0fa24467550ac">VertexData</a> (<a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *mgr=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a2396c78b8d5353f2f0f0fa24467550ac"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a7a588ae595eadd30f8f245afed2a5734">VertexData</a> (<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *dcl, <a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *bind)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a7a588ae595eadd30f8f245afed2a5734"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#acb2f442725d39e33a39f4d07f317fdc0">~VertexData</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#ad92e18126024740a16e296428786f7e1">clone</a> (bool copyData=true, <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *mgr=0) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Clones this vertex data, potentially including replicating any vertex buffers.  <a href="#ad92e18126024740a16e296428786f7e1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a35751c0e63acf6def8a1cf101abd1b28">prepareForShadowVolume</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Modifies the vertex data to be suitable for use for rendering shadow geometry.  <a href="#a35751c0e63acf6def8a1cf101abd1b28"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a106603d9d4d6c2f6e0d5eb6c25eb7c32">reorganiseBuffers</a> (<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *newDeclaration, const <a class="el" href="group__RenderSystem.html#ga14f5e9e50630af9964ebbbca9f88191b">BufferUsageList</a> &amp;bufferUsage, <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *mgr=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Reorganises the data in the vertex buffers according to the new vertex declaration passed in.  <a href="#a106603d9d4d6c2f6e0d5eb6c25eb7c32"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#ad1c61a5203430f896579775636e23d25">reorganiseBuffers</a> (<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *newDeclaration, <a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *mgr=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Reorganises the data in the vertex buffers according to the new vertex declaration passed in.  <a href="#ad1c61a5203430f896579775636e23d25"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a155a22e5f5cf3cc46c8890a81383ee19">closeGapsInBindings</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove any gaps in the vertex buffer bindings.  <a href="#a155a22e5f5cf3cc46c8890a81383ee19"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a9c8caba4952eb43bced5051c3e3bff1f">removeUnusedBuffers</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove all vertex buffers that never used by the vertex declaration.  <a href="#a9c8caba4952eb43bced5051c3e3bff1f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a0f6c57d776f87c08bb6fd6515f26270e">convertPackedColour</a> (<a class="el" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">VertexElementType</a> srcType, <a class="el" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">VertexElementType</a> destType)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert all packed colour values (VET_COLOUR_*) in buffers used to another type.  <a href="#a0f6c57d776f87c08bb6fd6515f26270e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#ad6f88995ea6fd3d8aeabd4b0cc90abc4">allocateHardwareAnimationElements</a> (<a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> count, bool animateNormals)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate elements to serve a holder of morph / pose target data for hardware morphing / pose blending.  <a href="#ad6f88995ea6fd3d8aeabd4b0cc90abc4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#abac9cde9c001b97cf1fea7fd05b79cf4">vertexDeclaration</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Declaration of the vertex to be used in this operation.  <a href="#abac9cde9c001b97cf1fea7fd05b79cf4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a1cf7dacb2a133d71620abd59cb3180b0">vertexBufferBinding</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The vertex buffer bindings to be used.  <a href="#a1cf7dacb2a133d71620abd59cb3180b0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a4cad19bf7cc1610d24d62f06149f9107">mDeleteDclBinding</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Whether this class should delete the declaration and binding.  <a href="#a4cad19bf7cc1610d24d62f06149f9107"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#aa3dca90128a99a8cdcd68201ad2c2f93">vertexStart</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The base vertex index to start from.  <a href="#aa3dca90128a99a8cdcd68201ad2c2f93"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a0b59b63cc2dbede1c5fc6a932fd2c10d">vertexCount</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of vertices used in this operation.  <a href="#a0b59b63cc2dbede1c5fc6a932fd2c10d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html#a8cbc3dcd7a4375b35b8595df246756e9">HardwareAnimationDataList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a43acb3f735c2d4bdfdfbfdebc26dc52e">hwAnimationDataList</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">VertexElements used for hardware morph / pose animation.  <a href="#a43acb3f735c2d4bdfdfbfdebc26dc52e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#af24c57003d9fa3d717ca16e7f5becb41">hwAnimDataItemsUsed</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of hardware animation data items used.  <a href="#af24c57003d9fa3d717ca16e7f5becb41"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a154124cc2848e3eae62e9d508f45e921">hardwareShadowVolWBuffer</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Additional shadow volume vertex buffer storage.  <a href="#a154124cc2848e3eae62e9d508f45e921"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#ac27bb140d24d66d1f6051f47a8bb5860">VertexData</a> (const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> &amp;rhs)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Protected copy constructor, to prevent misuse.  <a href="#ac27bb140d24d66d1f6051f47a8bb5860"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#ae1bb626aef6af169178ee9f7165aaed0">operator=</a> (const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> &amp;rhs)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Protected operator=, to prevent misuse.  <a href="#ae1bb626aef6af169178ee9f7165aaed0"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a53b43c61112a244ebc39ad112c964d52">mMgr</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Summary class collecting together vertex source information. </p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00048">48</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a8cbc3dcd7a4375b35b8595df246756e9"></a><!-- doxytag: member="Ogre::VertexData::HardwareAnimationDataList" ref="a8cbc3dcd7a4375b35b8595df246756e9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html">HardwareAnimationData</a>&gt;::type <a class="el" href="classOgre_1_1VertexData.html#a8cbc3dcd7a4375b35b8595df246756e9">Ogre::VertexData::HardwareAnimationDataList</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00098">98</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ac27bb140d24d66d1f6051f47a8bb5860"></a><!-- doxytag: member="Ogre::VertexData::VertexData" ref="ac27bb140d24d66d1f6051f47a8bb5860" args="(const VertexData &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html#ac27bb140d24d66d1f6051f47a8bb5860">Ogre::VertexData::VertexData</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Protected copy constructor, to prevent misuse. </p>

</div>
</div>
<a class="anchor" id="a2396c78b8d5353f2f0f0fa24467550ac"></a><!-- doxytag: member="Ogre::VertexData::VertexData" ref="a2396c78b8d5353f2f0f0fa24467550ac" args="(HardwareBufferManagerBase *mgr=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html#ac27bb140d24d66d1f6051f47a8bb5860">Ogre::VertexData::VertexData</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *&#160;</td>
          <td class="paramname"><em>mgr</em> = <code>0</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Constructor. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>This constructor creates the <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a> and <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a> automatically, and arranges for their deletion afterwards. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">mgr</td><td>Optional <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a> from which to create resources </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7a588ae595eadd30f8f245afed2a5734"></a><!-- doxytag: member="Ogre::VertexData::VertexData" ref="a7a588ae595eadd30f8f245afed2a5734" args="(VertexDeclaration *dcl, VertexBufferBinding *bind)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html#ac27bb140d24d66d1f6051f47a8bb5860">Ogre::VertexData::VertexData</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td>
          <td class="paramname"><em>dcl</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&#160;</td>
          <td class="paramname"><em>bind</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Constructor. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>This constructor receives the <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a> and <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a> from the caller, and as such does not arrange for their deletion afterwards, the caller remains responsible for that. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">dcl</td><td>The <a class="el" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a> to use </td></tr>
    <tr><td class="paramname">bind</td><td>The <a class="el" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a> to use </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="acb2f442725d39e33a39f4d07f317fdc0"></a><!-- doxytag: member="Ogre::VertexData::~VertexData" ref="acb2f442725d39e33a39f4d07f317fdc0" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html#acb2f442725d39e33a39f4d07f317fdc0">Ogre::VertexData::~VertexData</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ad6f88995ea6fd3d8aeabd4b0cc90abc4"></a><!-- doxytag: member="Ogre::VertexData::allocateHardwareAnimationElements" ref="ad6f88995ea6fd3d8aeabd4b0cc90abc4" args="(ushort count, bool animateNormals)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="el" href="classOgre_1_1VertexData.html#ad6f88995ea6fd3d8aeabd4b0cc90abc4">Ogre::VertexData::allocateHardwareAnimationElements</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>&#160;</td>
          <td class="paramname"><em>count</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>animateNormals</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate elements to serve a holder of morph / pose target data for hardware morphing / pose blending. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This method will allocate the given number of 3D texture coordinate sets for use as a morph target or target pose offset (3D position). These elements will be saved in hwAnimationDataList. It will also assume that the source of these new elements will be new buffers which are not bound at this time, so will start the sources to 1 higher than the current highest binding source. The caller is expected to bind these new buffers when appropriate. For morph animation the original position buffer will be the 'from' keyframe data, whilst for pose animation it will be the original vertex data. If normals are animated, then twice the number of 3D texture coordinates are required </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The number of sets that were supported </dd></dl>

</div>
</div>
<a class="anchor" id="ad92e18126024740a16e296428786f7e1"></a><!-- doxytag: member="Ogre::VertexData::clone" ref="ad92e18126024740a16e296428786f7e1" args="(bool copyData=true, HardwareBufferManagerBase *mgr=0) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a>* <a class="el" href="classOgre_1_1VertexData.html#ad92e18126024740a16e296428786f7e1">Ogre::VertexData::clone</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>copyData</em> = <code>true</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *&#160;</td>
          <td class="paramname"><em>mgr</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Clones this vertex data, potentially including replicating any vertex buffers. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">copyData</td><td>Whether to create new vertex buffers too or just reference the existing ones </td></tr>
    <tr><td class="paramname">mgr</td><td>If supplied, the buffer manager through which copies should be made </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The caller is expected to delete the returned pointer when ready </dd></dl>

</div>
</div>
<a class="anchor" id="a155a22e5f5cf3cc46c8890a81383ee19"></a><!-- doxytag: member="Ogre::VertexData::closeGapsInBindings" ref="a155a22e5f5cf3cc46c8890a81383ee19" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1VertexData.html#a155a22e5f5cf3cc46c8890a81383ee19">Ogre::VertexData::closeGapsInBindings</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove any gaps in the vertex buffer bindings. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This is useful if you've removed elements and buffers from this vertex data and want to remove any gaps in the vertex buffer bindings. This method is mainly useful when reorganising vertex data manually. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This will cause binding index of the elements in the vertex declaration to be altered to new binding index. </dd></dl>

</div>
</div>
<a class="anchor" id="a0f6c57d776f87c08bb6fd6515f26270e"></a><!-- doxytag: member="Ogre::VertexData::convertPackedColour" ref="a0f6c57d776f87c08bb6fd6515f26270e" args="(VertexElementType srcType, VertexElementType destType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1VertexData.html#a0f6c57d776f87c08bb6fd6515f26270e">Ogre::VertexData::convertPackedColour</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">VertexElementType</a>&#160;</td>
          <td class="paramname"><em>srcType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f">VertexElementType</a>&#160;</td>
          <td class="paramname"><em>destType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert all packed colour values (VET_COLOUR_*) in buffers used to another type. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">srcType</td><td>The source colour type to assume if the ambiguous VET_COLOUR is encountered. </td></tr>
    <tr><td class="paramname">destType</td><td>The destination colour type, must be VET_COLOUR_ABGR or VET_COLOUR_ARGB. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::VertexData::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::VertexData::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::VertexData::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::VertexData::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::VertexData::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::VertexData::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::VertexData::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::VertexData::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::VertexData::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::VertexData::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae1bb626aef6af169178ee9f7165aaed0"></a><!-- doxytag: member="Ogre::VertexData::operator=" ref="ae1bb626aef6af169178ee9f7165aaed0" args="(const VertexData &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a>&amp; Ogre::VertexData::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Protected operator=, to prevent misuse. </p>

</div>
</div>
<a class="anchor" id="a35751c0e63acf6def8a1cf101abd1b28"></a><!-- doxytag: member="Ogre::VertexData::prepareForShadowVolume" ref="a35751c0e63acf6def8a1cf101abd1b28" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1VertexData.html#a35751c0e63acf6def8a1cf101abd1b28">Ogre::VertexData::prepareForShadowVolume</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Modifies the vertex data to be suitable for use for rendering shadow geometry. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Preparing vertex data to generate a shadow volume involves firstly ensuring that the vertex buffer containing the positions is a standalone vertex buffer, with no other components in it. This method will therefore break apart any existing vertex buffers if position is sharing a vertex buffer. Secondly, it will double the size of this vertex buffer so that there are 2 copies of the position data for the mesh. The first half is used for the original, and the second half is used for the 'extruded' version. The vertex count used to render will remain the same though, so as not to add any overhead to regular rendering of the object. Both copies of the position are required in one buffer because shadow volumes stretch from the original mesh to the extruded version. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>It's important to appreciate that this method can fundamentally change the structure of your vertex buffers, although in reality they will be new buffers. As it happens, if other objects are using the original buffers then they will be unaffected because the reference counting will keep them intact. However, if you have made any assumptions about the structure of the vertex data in the buffers of this object, you may have to rethink them. </dd></dl>

</div>
</div>
<a class="anchor" id="a9c8caba4952eb43bced5051c3e3bff1f"></a><!-- doxytag: member="Ogre::VertexData::removeUnusedBuffers" ref="a9c8caba4952eb43bced5051c3e3bff1f" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1VertexData.html#a9c8caba4952eb43bced5051c3e3bff1f">Ogre::VertexData::removeUnusedBuffers</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove all vertex buffers that never used by the vertex declaration. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This is useful if you've removed elements from the vertex declaration and want to unreference buffers that never used any more. This method is mainly useful when reorganising vertex data manually. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This also remove any gaps in the vertex buffer bindings. </dd></dl>

</div>
</div>
<a class="anchor" id="a106603d9d4d6c2f6e0d5eb6c25eb7c32"></a><!-- doxytag: member="Ogre::VertexData::reorganiseBuffers" ref="a106603d9d4d6c2f6e0d5eb6c25eb7c32" args="(VertexDeclaration *newDeclaration, const BufferUsageList &amp;bufferUsage, HardwareBufferManagerBase *mgr=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1VertexData.html#a106603d9d4d6c2f6e0d5eb6c25eb7c32">Ogre::VertexData::reorganiseBuffers</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td>
          <td class="paramname"><em>newDeclaration</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__RenderSystem.html#ga14f5e9e50630af9964ebbbca9f88191b">BufferUsageList</a> &amp;&#160;</td>
          <td class="paramname"><em>bufferUsage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *&#160;</td>
          <td class="paramname"><em>mgr</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reorganises the data in the vertex buffers according to the new vertex declaration passed in. </p>
<p>Note that new vertex buffers are created and written to, so if the buffers being referenced by this vertex data object are also used by others, then the original buffers will not be damaged by this operation. Once this operation has completed, the new declaration passed in will overwrite the current one. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">newDeclaration</td><td>The vertex declaration which will be used for the reorganised buffer state. Note that the new declaration must not include any elements which do not already exist in the current declaration; you can drop elements by excluding them from the declaration if you wish, however. </td></tr>
    <tr><td class="paramname">bufferUsages</td><td>Vector of usage flags which indicate the usage options for each new vertex buffer created. The indexes of the entries must correspond to the buffer binding values referenced in the declaration. </td></tr>
    <tr><td class="paramname">mgr</td><td>Optional pointer to the manager to use to create new declarations and buffers etc. If not supplied, the <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a> singleton will be used </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad1c61a5203430f896579775636e23d25"></a><!-- doxytag: member="Ogre::VertexData::reorganiseBuffers" ref="ad1c61a5203430f896579775636e23d25" args="(VertexDeclaration *newDeclaration, HardwareBufferManagerBase *mgr=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1VertexData.html#a106603d9d4d6c2f6e0d5eb6c25eb7c32">Ogre::VertexData::reorganiseBuffers</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&#160;</td>
          <td class="paramname"><em>newDeclaration</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a> *&#160;</td>
          <td class="paramname"><em>mgr</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reorganises the data in the vertex buffers according to the new vertex declaration passed in. </p>
<p>Note that new vertex buffers are created and written to, so if the buffers being referenced by this vertex data object are also used by others, then the original buffers will not be damaged by this operation. Once this operation has completed, the new declaration passed in will overwrite the current one. This version of the method derives the buffer usages from the existing buffers, by using the 'most flexible' usage from the equivalent sources. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">newDeclaration</td><td>The vertex declaration which will be used for the reorganised buffer state. Note that the new delcaration must not include any elements which do not already exist in the current declaration; you can drop elements by excluding them from the declaration if you wish, however. </td></tr>
    <tr><td class="paramname">mgr</td><td>Optional pointer to the manager to use to create new declarations and buffers etc. If not supplied, the <a class="el" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a> singleton will be used </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a154124cc2848e3eae62e9d508f45e921"></a><!-- doxytag: member="Ogre::VertexData::hardwareShadowVolWBuffer" ref="a154124cc2848e3eae62e9d508f45e921" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> <a class="el" href="classOgre_1_1VertexData.html#a154124cc2848e3eae62e9d508f45e921">Ogre::VertexData::hardwareShadowVolWBuffer</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Additional shadow volume vertex buffer storage. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This additional buffer is only used where we have prepared this <a class="el" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> for use in shadow volume construction, and where the current render system supports vertex programs. This buffer contains the 'w' vertex position component which will be used by that program to differentiate between extruded and non-extruded vertices. This 'w' component cannot be included in the original position buffer because DirectX does not allow 4-component positions in the fixed-function pipeline, and the original position buffer must still be usable for fixed-function rendering. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>Note that we don't store any vertex declaration or vertex buffer binding here because this can be reused in the shadow algorithm. </dd></dl>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00145">145</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div>
<a class="anchor" id="a43acb3f735c2d4bdfdfbfdebc26dc52e"></a><!-- doxytag: member="Ogre::VertexData::hwAnimationDataList" ref="a43acb3f735c2d4bdfdfbfdebc26dc52e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html#a8cbc3dcd7a4375b35b8595df246756e9">HardwareAnimationDataList</a> <a class="el" href="classOgre_1_1VertexData.html#a43acb3f735c2d4bdfdfbfdebc26dc52e">Ogre::VertexData::hwAnimationDataList</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>VertexElements used for hardware morph / pose animation. </p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00100">100</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div>
<a class="anchor" id="af24c57003d9fa3d717ca16e7f5becb41"></a><!-- doxytag: member="Ogre::VertexData::hwAnimDataItemsUsed" ref="af24c57003d9fa3d717ca16e7f5becb41" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1VertexData.html#af24c57003d9fa3d717ca16e7f5becb41">Ogre::VertexData::hwAnimDataItemsUsed</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Number of hardware animation data items used. </p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00102">102</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4cad19bf7cc1610d24d62f06149f9107"></a><!-- doxytag: member="Ogre::VertexData::mDeleteDclBinding" ref="a4cad19bf7cc1610d24d62f06149f9107" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1VertexData.html#a4cad19bf7cc1610d24d62f06149f9107">Ogre::VertexData::mDeleteDclBinding</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Whether this class should delete the declaration and binding. </p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00085">85</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div>
<a class="anchor" id="a53b43c61112a244ebc39ad112c964d52"></a><!-- doxytag: member="Ogre::VertexData::mMgr" ref="a53b43c61112a244ebc39ad112c964d52" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareBufferManagerBase.html">HardwareBufferManagerBase</a>* <a class="el" href="classOgre_1_1VertexData.html#a53b43c61112a244ebc39ad112c964d52">Ogre::VertexData::mMgr</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00056">56</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1cf7dacb2a133d71620abd59cb3180b0"></a><!-- doxytag: member="Ogre::VertexData::vertexBufferBinding" ref="a1cf7dacb2a133d71620abd59cb3180b0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a>* <a class="el" href="classOgre_1_1VertexData.html#a1cf7dacb2a133d71620abd59cb3180b0">Ogre::VertexData::vertexBufferBinding</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The vertex buffer bindings to be used. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Note that this is created for you on construction. </dd></dl>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00083">83</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div>
<a class="anchor" id="a0b59b63cc2dbede1c5fc6a932fd2c10d"></a><!-- doxytag: member="Ogre::VertexData::vertexCount" ref="a0b59b63cc2dbede1c5fc6a932fd2c10d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1VertexData.html#a0b59b63cc2dbede1c5fc6a932fd2c10d">Ogre::VertexData::vertexCount</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The number of vertices used in this operation. </p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00089">89</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div>
<a class="anchor" id="abac9cde9c001b97cf1fea7fd05b79cf4"></a><!-- doxytag: member="Ogre::VertexData::vertexDeclaration" ref="abac9cde9c001b97cf1fea7fd05b79cf4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* <a class="el" href="classOgre_1_1VertexData.html#abac9cde9c001b97cf1fea7fd05b79cf4">Ogre::VertexData::vertexDeclaration</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Declaration of the vertex to be used in this operation. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Note that this is created for you on construction. </dd></dl>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00079">79</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa3dca90128a99a8cdcd68201ad2c2f93"></a><!-- doxytag: member="Ogre::VertexData::vertexStart" ref="aa3dca90128a99a8cdcd68201ad2c2f93" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1VertexData.html#aa3dca90128a99a8cdcd68201ad2c2f93">Ogre::VertexData::vertexStart</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The base vertex index to start from. </p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h_source.html#l00087">87</a> of file <a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreVertexIndexData_8h_source.html">OgreVertexIndexData.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:10
</p>
</body>
</html>
